import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsSku, GoodsSkuParam } from './model';
import { MODULES_API_URL } from '@/config/setting';
import { GoodsSpec } from '@/api/shop/goodsSpec/model';

export async function generateGoodsSku(data: GoodsSpec) {
  const res = await request.post<ApiResult<GoodsSku[]>>(
    MODULES_API_URL + '/shop/goods-sku/generateGoodsSku',
    data
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 分页查询商品sku列表
 */
export async function pageGoodsSku(params: GoodsSkuParam) {
  const res = await request.get<ApiResult<PageResult<GoodsSku>>>(
    MODULES_API_URL + '/shop/goods-sku/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品sku列表列表
 */
export async function listGoodsSku(params?: GoodsSkuParam) {
  const res = await request.get<ApiResult<GoodsSku[]>>(
    MODULES_API_URL + '/shop/goods-sku',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品sku列表
 */
export async function addGoodsSku(data: GoodsSku) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-sku',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品sku列表
 */
export async function updateGoodsSku(data: GoodsSku) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-sku',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品sku列表
 */
export async function removeGoodsSku(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-sku/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品sku列表
 */
export async function removeBatchGoodsSku(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-sku/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品sku列表
 */
export async function getGoodsSku(id: number) {
  const res = await request.get<ApiResult<GoodsSku>>(
    MODULES_API_URL + '/shop/goods-sku/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
